/**
* DevExtreme (core/devices.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface Device {
    /**
     */
    android?: boolean;
    /**
     */
    deviceType?: 'phone' | 'tablet' | 'desktop';
    /**
     */
    generic?: boolean;
    /**
     */
    grade?: 'A' | 'B' | 'C';
    /**
     */
    ios?: boolean;
    /**
     */
    phone?: boolean;
    /**
     */
    platform?: 'android' | 'ios' | 'generic';
    /**
     */
    tablet?: boolean;
    /**
     */
    version?: Array<number>;
}

/**
 */
declare class DevicesObject {
    constructor(options: { window?: Window });
    /**
     */
    current(): Device;
    /**
     */
    current(deviceName: string | Device): void;
    /**
     */
    off(eventName: string): this;
    /**
     */
    off(eventName: string, eventHandler: Function): this;
    /**
     */
    on(eventName: string, eventHandler: Function): this;
    /**
     */
    on(events: any): this;
    /**
     */
    orientation(): string;
    /**
     */
    real(): Device;
    isSimulator(): boolean;
}

/**
 * 
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
declare const devices: DevicesObject;
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default devices;
