/**
* DevExtreme (core/dom_component.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import Component, {
    ComponentOptions
} from './component';

import {
    Device
} from './devices';

import {
    dxElement
} from './element';

import { TemplateManager } from './template_manager';
import { FunctionTemplate } from './templates/function_template';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface DOMComponentOptions<T = DOMComponent> extends ComponentOptions<T> {
    /**
     */
    bindingOptions?: any;
    /**
     */
    elementAttr?: any;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    onDisposing?: ((e: { component?: T, element?: dxElement, model?: any }) => any);
    /**
     */
    onOptionChanged?: ((e: { component?: T, element?: dxElement, model?: any, name?: string, fullName?: string, value?: any }) => any);
    /**
     */
    rtlEnabled?: boolean;
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class DOMComponent extends Component {
    constructor(element: Element | JQuery, options?: DOMComponentOptions);
    /**
     */
    static defaultOptions(rule: { device?: Device | Array<Device> | Function, options?: any }): void;
    /**
     */
    dispose(): void;
    /**
     */
    element(): dxElement;
    /**
     */
    static getInstance(element: Element | JQuery): DOMComponent;

    $element(): Element | JQuery;
    _getTemplate(template: unknown): FunctionTemplate;
    _invalidate(): void;
    _refresh(): void;
    _templateManager: TemplateManager;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = DOMComponentOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = DOMComponentOptions;
