/**
* DevExtreme (renovation/viz/core/common/types.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Canvas = { left?: number; top?: number; right?: number; bottom?: number; width?: number; height?: number };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Size = { width?: number; height?: number };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type RecalculateCoordinates = {
  canvas: Canvas; anchorX: number; anchorY: number;
  size: Size; offset: number; arrowLength: number;
};
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type TooltipCoordinates = { x: number; y: number; anchorX: number; anchorY: number };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Margin = { top?: number; left?: number; bottom?: number; right?: number };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type InitialBorder = { color: string; width: number; dashStyle: string; opacity?: number; visible: boolean };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Border = { stroke?: string, strokeWidth?: number, strokeOpacity?: number, dashStyle?: string };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type CustomizedOptions = { text?: string, html?: string, color?: string, borderColor?: string, fontColor?: string };
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type CustomizeTooltipFn = (info: any) => {
    text?: string; html?: string; color?: string; borderColor?: string; fontColor?: string;
};
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Location = 'center' | 'edge';
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface TooltipData {
  value?: number | Date | string,
  argument?: number | Date | string,
  valueText?: string,
  argumentText?: string,
  originalValue?: number | Date | string,
  originalArgument?: number | Date | string,
  seriesName?: string,
  description?: string
}
