/**
 * DevExtreme (renovation/viz/sparklines/bullet.js)
 * Version: 21.1.0 (build 20361-0317)
 * Build date: Sat Dec 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.Bullet = Bullet;
exports.BulletProps = exports.viewFunction = void 0;
var _combine_classes = require("../../utils/combine_classes");
var _resolve_rtl = require("../../utils/resolve_rtl");
var _base_props = require("../core/base_props");
var _base_widget = require("../core/base_widget");
var _utils = require("./utils");
var _config_context = require("../../common/config_context");
var _svg_path = require("../core/renderers/svg_path");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}
var TARGET_MIN_Y = .02;
var TARGET_MAX_Y = .98;
var BAR_VALUE_MIN_Y = .1;
var BAR_VALUE_MAX_Y = .9;
var DEFAULT_CANVAS_WIDTH = 300;
var DEFAULT_CANVAS_HEIGHT = 30;
var DEFAULT_HORIZONTAL_MARGIN = 1;
var DEFAULT_VERTICAL_MARGIN = 2;
var isValidBulletScale = function(props) {
    var endScaleValue = props.endScaleValue,
        startScaleValue = props.startScaleValue,
        target = props.target,
        value = props.value;
    var isValidBounds = startScaleValue !== endScaleValue;
    var isValidMin = Number.isFinite(startScaleValue);
    var isValidMax = Number.isFinite(endScaleValue);
    var isValidValue = Number.isFinite(value);
    var isValidTarget = Number.isFinite(target);
    return isValidBounds && isValidMax && isValidMin && isValidTarget && isValidValue
};
var getCssClasses = function(_ref) {
    var classes = _ref.classes;
    var rootClassesMap = _defineProperty({
        dxb: true,
        "dxb-bullet": true
    }, String(classes), !!classes);
    return (0, _combine_classes.combineClasses)(rootClassesMap)
};
var getContainerCssClasses = function(_ref2) {
    var className = _ref2.className;
    var rootClassesMap = _defineProperty({
        "dx-bullet": true
    }, String(className), !!className);
    return (0, _combine_classes.combineClasses)(rootClassesMap)
};
var viewFunction = function(viewModel) {
    var scaleProps = viewModel.prepareInternalComponents();
    var isValidBullet = isValidBulletScale(scaleProps);
    return Preact.h(_base_widget.BaseWidget, _extends({
        ref: viewModel.widgetRef,
        classes: viewModel.cssClasses,
        className: viewModel.cssClassName,
        size: viewModel.props.size,
        margin: viewModel.props.margin,
        defaultCanvas: viewModel.defaultCanvas,
        disabled: viewModel.props.disabled,
        rtlEnabled: viewModel.rtlEnabled,
        onContentReady: viewModel.props.onContentReady,
        canvasChange: viewModel.onCanvasChange,
        pointerEvents: "visible"
    }, viewModel.restAttributes), isValidBullet && Preact.h(_svg_path.PathSvgElement, {
        type: "line",
        points: viewModel.getBarValueShape(scaleProps),
        className: "dxb-bar-value",
        strokeLineCap: "square",
        fill: viewModel.props.color
    }), isValidBullet && viewModel.isValidTarget(scaleProps) && Preact.h(_svg_path.PathSvgElement, {
        type: "line",
        points: viewModel.getTargetShape(scaleProps),
        className: "dxb-target",
        sharp: true,
        strokeLineCap: "square",
        stroke: viewModel.props.targetColor,
        strokeWidth: viewModel.props.targetWidth
    }), isValidBullet && viewModel.isValidZeroLevel(scaleProps) && Preact.h(_svg_path.PathSvgElement, {
        type: "line",
        points: viewModel.getZeroLevelShape(),
        className: "dxb-zero-level",
        sharp: true,
        strokeLineCap: "square",
        stroke: viewModel.props.targetColor,
        strokeWidth: 1
    }))
};
exports.viewFunction = viewFunction;
var BulletProps = _objectSpread(_objectSpread({}, _base_props.BaseWidgetProps), {}, {
    value: 0,
    color: "#e8c267",
    target: 0,
    targetColor: "#666666",
    targetWidth: 4,
    showTarget: true,
    showZeroLevel: true,
    startScaleValue: 0
});
exports.BulletProps = BulletProps;

function Bullet(props) {
    var __widgetRef = (0, _hooks.useRef)();
    var _useState = (0, _hooks.useState)((function() {
            return void 0 !== props.canvas ? props.canvas : props.defaultCanvas
        })),
        _useState2 = _slicedToArray(_useState, 2),
        __state_canvas = _useState2[0];
    _useState2[1];
    var _useState3 = (0, _hooks.useState)((0, _utils.createAxis)(true)),
        _useState4 = _slicedToArray(_useState3, 2),
        __state_argumentAxis = _useState4[0];
    _useState4[1];
    var _useState5 = (0, _hooks.useState)((0, _utils.createAxis)(false)),
        _useState6 = _slicedToArray(_useState5, 2),
        __state_valueAxis = _useState6[0];
    _useState6[1];
    var _useState7 = (0, _hooks.useState)({
            width: 0,
            height: 0,
            top: 0,
            left: 0,
            bottom: 0,
            right: 0
        }),
        _useState8 = _slicedToArray(_useState7, 2),
        __state_canvasState = _useState8[0],
        __state_setCanvasState = _useState8[1];
    var config = (0, _hooks.useContext)(_config_context.ConfigContext);
    var __cssClasses = (0, _hooks.useCallback)((function() {
        var classes = props.classes;
        return getCssClasses({
            classes: classes
        })
    }), [props.classes]);
    var __cssClassName = (0, _hooks.useCallback)((function() {
        var className = props.className;
        return getContainerCssClasses({
            className: className
        })
    }), [props.className]);
    var __rtlEnabled = (0, _hooks.useCallback)((function() {
        var rtlEnabled = props.rtlEnabled;
        return (0, _resolve_rtl.resolveRtlEnabled)(rtlEnabled, config)
    }), [props.rtlEnabled, config]);
    var __tooltipEnabled = (0, _hooks.useCallback)((function() {
        return !(void 0 === props.value && void 0 === props.target)
    }), [props.value, props.target]);
    var __defaultCanvas = (0, _hooks.useCallback)((function() {
        return {
            width: DEFAULT_CANVAS_WIDTH,
            height: DEFAULT_CANVAS_HEIGHT,
            left: DEFAULT_HORIZONTAL_MARGIN,
            right: DEFAULT_HORIZONTAL_MARGIN,
            top: DEFAULT_VERTICAL_MARGIN,
            bottom: DEFAULT_VERTICAL_MARGIN
        }
    }), []);
    var __onCanvasChange = (0, _hooks.useCallback)((function(canvas) {
        __state_setCanvasState((function(__state_canvasState) {
            return canvas
        }))
    }), []);
    var __prepareInternalComponents = (0, _hooks.useCallback)((function() {
        var props = __prepareScaleProps();
        __updateWidgetElements(props);
        return props
    }), [props.value, props.target, props.startScaleValue, props.endScaleValue, __state_canvasState, props.rtlEnabled, config, __state_argumentAxis, __state_valueAxis]);
    var __updateWidgetElements = (0, _hooks.useCallback)((function(props) {
        var canvas = __state_canvasState;
        var ranges = __updateRange(props);
        __state_argumentAxis.update(ranges.arg, canvas, void 0);
        __state_valueAxis.update(ranges.val, canvas, void 0)
    }), [__state_canvasState, props.rtlEnabled, config, __state_argumentAxis, __state_valueAxis]);
    var __prepareScaleProps = (0, _hooks.useCallback)((function() {
        var level;
        var tmpProps = {
            inverted: false,
            value: void 0 !== props.value ? Number(props.value) : 0,
            target: void 0 !== props.target ? Number(props.target) : 0,
            startScaleValue: 0,
            endScaleValue: 0
        };
        var target = tmpProps.target,
            value = tmpProps.value;
        if (void 0 === props.startScaleValue) {
            tmpProps.startScaleValue = target < value ? target : value;
            tmpProps.startScaleValue = tmpProps.startScaleValue < 0 ? tmpProps.startScaleValue : 0
        } else {
            tmpProps.startScaleValue = Number(props.startScaleValue)
        }
        tmpProps.endScaleValue = void 0 === props.endScaleValue ? target > value ? target : value : Number(props.endScaleValue);
        var endScaleValue = tmpProps.endScaleValue,
            startScaleValue = tmpProps.startScaleValue;
        if (endScaleValue < startScaleValue) {
            level = endScaleValue;
            tmpProps.endScaleValue = startScaleValue;
            tmpProps.startScaleValue = level;
            tmpProps.inverted = true
        }
        return tmpProps
    }), [props.value, props.target, props.startScaleValue, props.endScaleValue]);
    var __updateRange = (0, _hooks.useCallback)((function(scaleProps) {
        var endScaleValue = scaleProps.endScaleValue,
            inverted = scaleProps.inverted,
            startScaleValue = scaleProps.startScaleValue;
        return {
            arg: {
                invert: __rtlEnabled() ? !inverted : inverted,
                min: startScaleValue,
                max: endScaleValue,
                axisType: "continuous",
                dataType: "numeric"
            },
            val: {
                min: 0,
                max: 1,
                axisType: "continuous",
                dataType: "numeric"
            }
        }
    }), [props.rtlEnabled, config]);
    var __getBarValueShape = (0, _hooks.useCallback)((function(props) {
        var translatorX = __state_argumentAxis.getTranslator();
        var translatorY = __state_valueAxis.getTranslator();
        var endScaleValue = props.endScaleValue,
            startScaleValue = props.startScaleValue,
            value = props.value;
        var y2 = translatorY.translate(BAR_VALUE_MIN_Y);
        var y1 = translatorY.translate(BAR_VALUE_MAX_Y);
        var x1;
        var x2;
        if (value > 0) {
            x1 = startScaleValue <= 0 ? 0 : startScaleValue;
            x2 = value >= endScaleValue ? endScaleValue : value < x1 ? x1 : value
        } else {
            x1 = endScaleValue >= 0 ? 0 : endScaleValue;
            x2 = value < startScaleValue ? startScaleValue : value > x1 ? x1 : value
        }
        x1 = translatorX.translate(x1);
        x2 = translatorX.translate(x2);
        return [x1, y1, x2, y1, x2, y2, x1, y2]
    }), [__state_argumentAxis, __state_valueAxis]);
    var __getSimpleShape = (0, _hooks.useCallback)((function(value) {
        var translatorY = __state_valueAxis.getTranslator();
        var x = __state_argumentAxis.getTranslator().translate(value);
        return [x, translatorY.translate(TARGET_MIN_Y), x, translatorY.translate(TARGET_MAX_Y)]
    }), [__state_valueAxis, __state_argumentAxis]);
    var __getTargetShape = (0, _hooks.useCallback)((function(props) {
        return __getSimpleShape(props.target)
    }), [__state_valueAxis, __state_argumentAxis]);
    var __getZeroLevelShape = (0, _hooks.useCallback)((function() {
        return __getSimpleShape(0)
    }), [__state_valueAxis, __state_argumentAxis]);
    var __isValidTarget = (0, _hooks.useCallback)((function(scaleProps) {
        var endScaleValue = scaleProps.endScaleValue,
            startScaleValue = scaleProps.startScaleValue,
            target = scaleProps.target;
        var showTarget = props.showTarget;
        return !(target > endScaleValue || target < startScaleValue || !showTarget)
    }), [props.showTarget]);
    var __isValidZeroLevel = (0, _hooks.useCallback)((function(scaleProps) {
        var endScaleValue = scaleProps.endScaleValue,
            startScaleValue = scaleProps.startScaleValue;
        var showZeroLevel = props.showZeroLevel;
        return !(endScaleValue < 0 || startScaleValue > 0 || !showZeroLevel)
    }), [props.showZeroLevel]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        var _props$canvas = _objectSpread(_objectSpread({}, props), {}, {
                canvas: void 0 !== props.canvas ? props.canvas : __state_canvas
            }),
            restProps = (_props$canvas.canvas, _props$canvas.canvasChange, _props$canvas.children, _props$canvas.className, _props$canvas.classes, _props$canvas.color, _props$canvas.defaultCanvas, _props$canvas.disabled, _props$canvas.endScaleValue, _props$canvas.margin, _props$canvas.onContentReady, _props$canvas.pointerEvents, _props$canvas.rtlEnabled, _props$canvas.showTarget, _props$canvas.showZeroLevel, _props$canvas.size, _props$canvas.startScaleValue, _props$canvas.target, _props$canvas.targetColor, _props$canvas.targetWidth, _props$canvas.value, _objectWithoutProperties(_props$canvas, ["canvas", "canvasChange", "children", "className", "classes", "color", "defaultCanvas", "disabled", "endScaleValue", "margin", "onContentReady", "pointerEvents", "rtlEnabled", "showTarget", "showZeroLevel", "size", "startScaleValue", "target", "targetColor", "targetWidth", "value"]));
        return restProps
    }), [props, __state_canvas]);
    return viewFunction({
        props: _objectSpread(_objectSpread({}, props), {}, {
            canvas: void 0 !== props.canvas ? props.canvas : __state_canvas
        }),
        argumentAxis: __state_argumentAxis,
        valueAxis: __state_valueAxis,
        canvasState: __state_canvasState,
        widgetRef: __widgetRef,
        config: config,
        cssClasses: __cssClasses(),
        cssClassName: __cssClassName(),
        rtlEnabled: __rtlEnabled(),
        tooltipEnabled: __tooltipEnabled(),
        defaultCanvas: __defaultCanvas(),
        onCanvasChange: __onCanvasChange,
        prepareInternalComponents: __prepareInternalComponents,
        updateWidgetElements: __updateWidgetElements,
        prepareScaleProps: __prepareScaleProps,
        updateRange: __updateRange,
        getBarValueShape: __getBarValueShape,
        getSimpleShape: __getSimpleShape,
        getTargetShape: __getTargetShape,
        getZeroLevelShape: __getZeroLevelShape,
        isValidTarget: __isValidTarget,
        isValidZeroLevel: __isValidZeroLevel,
        restAttributes: __restAttributes()
    })
}
Bullet.defaultProps = _objectSpread({}, BulletProps);
