/**
* DevExtreme (ui/drop_down_editor/ui.drop_down_editor.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    dxElement
} from '../../core/element';

import {
    template
} from '../../core/templates/template';

import dxTextBox, {
    dxTextBoxOptions
} from '../text_box';

import {
    dxTextEditorButton
} from '../text_box/ui.text_editor.base';

import {
    dxPopupOptions
} from '../popup';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDropDownEditorOptions<T = dxDropDownEditor> extends dxTextBoxOptions<T> {
    /**
     */
    acceptCustomValue?: boolean;
    /**
     */
    activeStateEnabled?: boolean;
    /**
     */
    applyValueMode?: 'instantly' | 'useButtons';
    /**
     */
    dropDownOptions?: dxPopupOptions;
    /**
     */
    buttons?: Array<'clear' | 'dropDown' | dxTextEditorButton>;
    /**
     */
    deferRendering?: boolean;
    /**
     */
    dropDownButtonTemplate?: template | ((buttonData: { text?: string, icon?: string }, contentElement: dxElement) => string | Element | JQuery);
    /**
     */
    onClosed?: ((e: { component?: T, element?: dxElement, model?: any }) => any);
    /**
     */
    onOpened?: ((e: { component?: T, element?: dxElement, model?: any }) => any);
    /**
     */
    openOnFieldClick?: boolean;
    /**
     */
    opened?: boolean;
    /**
     */
    showDropDownButton?: boolean;
    /**
     */
    value?: any;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class dxDropDownEditor extends dxTextBox {
    constructor(element: Element, options?: dxDropDownEditorOptions)
    constructor(element: JQuery, options?: dxDropDownEditorOptions)
    /**
     */
    close(): void;
    /**
     */
    content(): dxElement;
    /**
     */
    field(): dxElement;
    /**
     */
    open(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxDropDownEditorOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxDropDownEditorOptions;
