/**
* DevExtreme (ui/drop_down_editor/ui.drop_down_list.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../../jquery_augmentation';

import {
    dxElement
} from '../../core/element';

import {
    template
} from '../../core/templates/template';

import DataSource from '../../data/data_source';

import {
    event
} from '../../events/index';

import {
    DataExpressionMixinOptions
} from '../editor/ui.data_expression';

import dxDropDownEditor, {
    dxDropDownEditorOptions
} from './ui.drop_down_editor';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxDropDownListOptions<T = dxDropDownList> extends DataExpressionMixinOptions<T>, dxDropDownEditorOptions<T> {
    /**
     */
    displayValue?: string;
    /**
     */
    groupTemplate?: template | ((itemData: any, itemIndex: number, itemElement: dxElement) => string | Element | JQuery);
    /**
     */
    grouped?: boolean;
    /**
     */
    minSearchLength?: number;
    /**
     */
    noDataText?: string;
    /**
     */
    onItemClick?: ((e: { component?: T, element?: dxElement, model?: any, itemData?: any, itemElement?: any, itemIndex?: number | any, event?: event }) => any);
    /**
     */
    onSelectionChanged?: ((e: { component?: T, element?: dxElement, model?: any, selectedItem?: any }) => any);
    /**
     */
    onValueChanged?: ((e: { component?: T, element?: dxElement, model?: any, value?: any, previousValue?: any, event?: event }) => any);
    /**
     */
    searchEnabled?: boolean;
    /**
     */
    searchExpr?: string | Function | Array<string | Function>;
    /**
     */
    searchMode?: 'contains' | 'startswith';
    /**
     */
    searchTimeout?: number;
    /**
     */
    selectedItem?: any;
    /**
     */
    showDataBeforeSearch?: boolean;
    /**
     */
    value?: any;
    /**
     */
    valueChangeEvent?: string;
    /**
     */
    wrapItemText?: boolean;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class dxDropDownList extends dxDropDownEditor {
    constructor(element: Element, options?: dxDropDownListOptions)
    constructor(element: JQuery, options?: dxDropDownListOptions)
    getDataSource(): DataSource;
}
