/**
* DevExtreme (ui/map.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import {
    dxElement
} from '../core/element';

import {
    event
} from '../events/index';

import Widget, {
    WidgetOptions
} from './widget/ui.widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface MapLocation {
    /**
     */
    lat?: number;
    /**
     */
    lng?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxMapOptions extends WidgetOptions<dxMap> {
    /**
     */
    apiKey?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      bing?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      google?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      googleStatic?: string
    };
    /**
     */
    autoAdjust?: boolean;
    /**
     */
    center?: any | string | Array<number>;
    /**
     */
    controls?: boolean;
    /**
     */
    focusStateEnabled?: boolean;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     * @deprecated
     */
    key?: string | {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      bing?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      google?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      googleStatic?: string
    };
    /**
     */
    markerIconSrc?: string;
    /**
     */
    markers?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      iconSrc?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      location?: any | string | Array<number>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      onClick?: Function,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      tooltip?: string | {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        isShown?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        text?: string
      }
    }>;
    /**
     */
    onClick?: ((e: { component?: dxMap, element?: dxElement, model?: any, location?: any, event?: event }) => any) | string;
    /**
     */
    onMarkerAdded?: ((e: { component?: dxMap, element?: dxElement, model?: any, options?: any, originalMarker?: any }) => any);
    /**
     */
    onMarkerRemoved?: ((e: { component?: dxMap, element?: dxElement, model?: any, options?: any }) => any);
    /**
     */
    onReady?: ((e: { component?: dxMap, element?: dxElement, model?: any, originalMap?: any }) => any);
    /**
     */
    onRouteAdded?: ((e: { component?: dxMap, element?: dxElement, model?: any, options?: any, originalRoute?: any }) => any);
    /**
     */
    onRouteRemoved?: ((e: { component?: dxMap, element?: dxElement, model?: any, options?: any }) => any);
    /**
     */
    provider?: 'bing' | 'google' | 'googleStatic';
    /**
     */
    routes?: Array<{
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      locations?: Array<any>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      mode?: 'driving' | 'walking',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      opacity?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      weight?: number
    }>;
    /**
     */
    type?: 'hybrid' | 'roadmap' | 'satellite';
    /**
     */
    width?: number | string | (() => number | string);
    /**
     */
    zoom?: number;
}
/**
 */
export default class dxMap extends Widget {
    constructor(element: Element, options?: dxMapOptions)
    constructor(element: JQuery, options?: dxMapOptions)
    /**
     */
    addMarker(markerOptions: any | Array<any>): Promise<any> & JQueryPromise<any>;
    /**
     */
    addRoute(options: any | Array<any>): Promise<any> & JQueryPromise<any>;
    /**
     */
    removeMarker(marker: any | number | Array<any>): Promise<void> & JQueryPromise<void>;
    /**
     */
    removeRoute(route: any | number | Array<any>): Promise<void> & JQueryPromise<void>;
}

declare global {
interface JQuery {
    dxMap(): JQuery;
    dxMap(options: "instance"): dxMap;
    dxMap(options: string): any;
    dxMap(options: string, ...params: any[]): any;
    dxMap(options: dxMapOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxMapOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxMapOptions;
