/**
* DevExtreme (ui/toast.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    animationConfig
} from '../animation/fx';

import {
    positionConfig
} from '../animation/position';

import {
    event
} from '../events/index';

import dxOverlay, {
    dxOverlayAnimation,
    dxOverlayOptions
} from './overlay';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxToastOptions extends dxOverlayOptions<dxToast> {
    /**
     */
    animation?: dxToastAnimation;
    /**
     */
    closeOnClick?: boolean;
    /**
     */
    closeOnOutsideClick?: boolean | ((event: event) => boolean);
    /**
     */
    closeOnSwipe?: boolean;
    /**
     */
    displayTime?: number;
    /**
     */
    height?: number | string | (() => number | string);
    /**
     */
    maxWidth?: number | string | (() => number | string);
    /**
     */
    message?: string;
    /**
     */
    minWidth?: number | string | (() => number | string);
    /**
     */
    position?: positionConfig | string;
    /**
     */
    shading?: boolean;
    /**
     */
    type?: 'custom' | 'error' | 'info' | 'success' | 'warning';
    /**
     */
    width?: number | string | (() => number | string);
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxToastAnimation extends dxOverlayAnimation {
    /**
     * An object that defines the animation options used when the widget is being hidden.
     */
    hide?: animationConfig;
    /**
     * An object that defines the animation options used when the widget is being shown.
     */
    show?: animationConfig;
}
/**
 */
export default class dxToast extends dxOverlay {
    constructor(element: Element, options?: dxToastOptions)
    constructor(element: JQuery, options?: dxToastOptions)
}

declare global {
interface JQuery {
    dxToast(): JQuery;
    dxToast(options: "instance"): dxToast;
    dxToast(options: string): any;
    dxToast(options: string, ...params: any[]): any;
    dxToast(options: dxToastOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxToastOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxToastOptions;
