/**
* DevExtreme (viz/bullet.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import BaseSparkline, {
    BaseSparklineOptions
} from './sparklines/base_sparkline';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxBulletOptions extends BaseSparklineOptions<dxBullet> {
    /**
     */
    color?: string;
    /**
     */
    endScaleValue?: number;
    /**
     */
    showTarget?: boolean;
    /**
     */
    showZeroLevel?: boolean;
    /**
     */
    startScaleValue?: number;
    /**
     */
    target?: number;
    /**
     */
    targetColor?: string;
    /**
     */
    targetWidth?: number;
    /**
     */
    value?: number;
}
/**
 */
export default class dxBullet extends BaseSparkline {
    constructor(element: Element, options?: dxBulletOptions)
    constructor(element: JQuery, options?: dxBulletOptions)
}

declare global {
interface JQuery {
    dxBullet(): JQuery;
    dxBullet(options: "instance"): dxBullet;
    dxBullet(options: string): any;
    dxBullet(options: string, ...params: any[]): any;
    dxBullet(options: dxBulletOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxBulletOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxBulletOptions;
