/**
* DevExtreme (viz/linear_gauge.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    BaseGauge,
    BaseGaugeOptions,
    BaseGaugeRangeContainer,
    BaseGaugeScale,
    BaseGaugeScaleLabel,
    GaugeIndicator
} from './gauges/base_gauge';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLinearGaugeOptions extends BaseGaugeOptions<dxLinearGauge> {
    /**
     */
    geometry?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      orientation?: 'horizontal' | 'vertical'
    };
    /**
     */
    rangeContainer?: dxLinearGaugeRangeContainer;
    /**
     */
    scale?: dxLinearGaugeScale;
    /**
     */
    subvalueIndicator?: GaugeIndicator;
    /**
     */
    valueIndicator?: GaugeIndicator;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLinearGaugeRangeContainer extends BaseGaugeRangeContainer {
    /**
     * Specifies the orientation of the range container. Applies only if the geometry.orientation option is 'vertical'.
     */
    horizontalOrientation?: 'center' | 'left' | 'right';
    /**
     * Specifies the orientation of the range container. Applies only if the geometry.orientation option is 'horizontal'.
     */
    verticalOrientation?: 'bottom' | 'center' | 'top';
    /**
     * Specifies the width of the range container's start and end boundaries in the LinearGauge widget.
     */
    width?: {
      /**
       * Specifies a start width of a range container.
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      start?: number,
      /**
       * Specifies an end width of a range container.
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      end?: number
    } | number;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLinearGaugeScale extends BaseGaugeScale {
    /**
     * Specifies the orientation of scale ticks. Applies only if the geometry.orientation option is 'vertical'.
     */
    horizontalOrientation?: 'center' | 'left' | 'right';
    /**
     * Specifies common options for scale labels.
     */
    label?: dxLinearGaugeScaleLabel;
    /**
     * Specifies the minimum distance between two neighboring major ticks in pixels.
     */
    scaleDivisionFactor?: number;
    /**
     * Specifies the orientation of scale ticks. Applies only if the geometry.orientation option is 'horizontal'.
     */
    verticalOrientation?: 'bottom' | 'center' | 'top';
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxLinearGaugeScaleLabel extends BaseGaugeScaleLabel {
    /**
     * Specifies the spacing between scale labels and ticks.
     */
    indentFromTick?: number;
}
/**
 */
export default class dxLinearGauge extends BaseGauge {
    constructor(element: Element, options?: dxLinearGaugeOptions)
    constructor(element: JQuery, options?: dxLinearGaugeOptions)
}

declare global {
interface JQuery {
    dxLinearGauge(): JQuery;
    dxLinearGauge(options: "instance"): dxLinearGauge;
    dxLinearGauge(options: string): any;
    dxLinearGauge(options: string, ...params: any[]): any;
    dxLinearGauge(options: dxLinearGaugeOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxLinearGaugeOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxLinearGaugeOptions;
