/**
* DevExtreme (viz/sankey.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    dxElement
} from '../core/element';

import {
    PaletteType,
    PaletteExtensionModeType
} from './palette';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    event
} from '../events/index';

import BaseWidget, {
    BaseWidgetOptions,
    BaseWidgetTooltip,
    Font
} from './core/base_widget';

import { HatchingDirectionType } from './common';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSankeyOptions extends BaseWidgetOptions<dxSankey> {
    /**
     */
    adaptiveLayout?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      height?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      keepLabels?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    alignment?: 'bottom' | 'center' | 'top' | Array<'bottom' | 'center' | 'top'>;
    /**
     */
    dataSource?: Array<any> | DataSource | DataSourceOptions | string;
    /**
     */
    hoverEnabled?: boolean;
    /**
     */
    label?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      border?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        visible?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      customizeText?: ((itemInfo: dxSankeyNode) => string),
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      font?: Font,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      horizontalOffset?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      overlappingBehavior?: 'ellipsis' | 'hide' | 'none',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      shadow?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        blur?: number,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        offsetX?: number,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        offsetY?: number,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        opacity?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      useNodeColors?: boolean,
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      verticalOffset?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      visible?: boolean
    };
    /**
     */
    link?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      border?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        visible?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      colorMode?: 'none' | 'source' | 'target' | 'gradient',
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hoverStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          visible?: boolean,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        hatching?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          direction?: HatchingDirectionType,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          opacity?: number,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          step?: number,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
        opacity?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      opacity?: number
    };
    /**
     */
    node?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      border?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        visible?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hoverStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          visible?: boolean,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        hatching?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          direction?: HatchingDirectionType,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          opacity?: number,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          step?: number,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
        opacity?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      opacity?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      padding?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      width?: number
    };
    /**
     */
    onLinkClick?: ((e: { component?: dxSankey, element?: dxElement, model?: any, event?: event, target?: dxSankeyLink }) => any) | string;
    /**
     */
    onLinkHoverChanged?: ((e: { component?: dxSankey, element?: dxElement, model?: any, target?: dxSankeyLink }) => any);
    /**
     */
    onNodeClick?: ((e: { component?: dxSankey, element?: dxElement, model?: any, event?: event, target?: dxSankeyNode }) => any) | string;
    /**
     */
    onNodeHoverChanged?: ((e: { component?: dxSankey, element?: dxElement, model?: any, target?: dxSankeyNode }) => any);
    /**
     */
    palette?: Array<string> | PaletteType;
    /**
     */
    paletteExtensionMode?: PaletteExtensionModeType;
    /**
     */
    sortData?: any;
    /**
     */
    sourceField?: string;
    /**
     */
    targetField?: string;
    /**
     */
    tooltip?: dxSankeyTooltip;
    /**
     */
    weightField?: string;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSankeyTooltip extends BaseWidgetTooltip {
    /**
     * Customizes link tooltips' appearance.
     */
    customizeLinkTooltip?: ((info: { source?: string, target?: string, weight?: number }) => any);
    /**
     * Customizes node tooltips' appearance.
     */
    customizeNodeTooltip?: ((info: { title?: string, label?: string, weightIn?: number, weightOut?: number }) => any);
    /**
     * Enables tooltips.
     */
    enabled?: boolean;
    /**
     * Specifies a custom template for a link's tooltip.
     */
    linkTooltipTemplate?: template | ((info: { source?: string, target?: string, weight?: number }, element: dxElement) => string | Element | JQuery);
    /**
     * Specifies a custom template for a node's tooltip.
     */
    nodeTooltipTemplate?: template | ((info: { label?: string, weightIn?: number, weightOut?: number }, element: dxElement) => string | Element | JQuery);
}
/**
 */
export default class dxSankey extends BaseWidget {
    constructor(element: Element, options?: dxSankeyOptions)
    constructor(element: JQuery, options?: dxSankeyOptions)
    /**
     */
    getAllLinks(): Array<dxSankeyLink>;
    /**
     */
    getAllNodes(): Array<dxSankeyNode>;
    getDataSource(): DataSource;
    /**
     */
    hideTooltip(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSankeyConnectionInfoObject {
    /**
     */
    source?: string;
    /**
     */
    target?: string;
    /**
     */
    weight?: number;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSankeyLink {
    /**
     */
    connection?: dxSankeyConnectionInfoObject;
    /**
     */
    hideTooltip(): void;
    /**
     */
    hover(state: boolean): void;
    /**
     */
    isHovered(): boolean;
    /**
     */
    showTooltip(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxSankeyNode {
    /**
     */
    hideTooltip(): void;
    /**
     */
    hover(state: boolean): void;
    /**
     */
    isHovered(): boolean;
    /**
     */
    label?: string;
    /**
     */
    linksIn?: Array<any>;
    /**
     */
    linksOut?: Array<any>;
    /**
     */
    showTooltip(): void;
    /**
     * @deprecated
     */
    title?: string;
}

declare global {
interface JQuery {
    dxSankey(): JQuery;
    dxSankey(options: "instance"): dxSankey;
    dxSankey(options: string): any;
    dxSankey(options: string, ...params: any[]): any;
    dxSankey(options: dxSankeyOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxSankeyOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxSankeyOptions;
