/**
* DevExtreme (viz/sparklines/base_sparkline.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    dxElement
} from '../../core/element';

import {
    template
} from '../../core/templates/template';

import BaseWidget, {
    BaseWidgetExport,
    BaseWidgetLoadingIndicator,
    BaseWidgetOptions,
    BaseWidgetTitle,
    BaseWidgetTooltip
} from '../core/base_widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface BaseSparklineOptions<T = BaseSparkline> extends BaseWidgetOptions<T> {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    export?: BaseWidgetExport;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    loadingIndicator?: BaseWidgetLoadingIndicator;
    /**
     */
    onTooltipHidden?: ((e: { component?: T, element?: dxElement, model?: any }) => any);
    /**
     */
    onTooltipShown?: ((e: { component?: T, element?: dxElement, model?: any }) => any);
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    redrawOnResize?: boolean;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    title?: BaseWidgetTitle | string;
    /**
     */
    tooltip?: BaseSparklineTooltip;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface BaseSparklineTooltip extends BaseWidgetTooltip {
    /**
     * Specifies a custom template for tooltips.
     */
    contentTemplate?: template | ((pointsInfo: any, element: dxElement) => string | Element | JQuery);
    /**
     * Allows you to change tooltip appearance.
     */
    customizeTooltip?: ((pointsInfo: any) => any);
    /**
     * Enables tooltips.
     */
    enabled?: boolean;
    /**
     * 
     */
    interactive?: boolean;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export default class BaseSparkline extends BaseWidget {
    constructor(element: Element, options?: BaseSparklineOptions)
    constructor(element: JQuery, options?: BaseSparklineOptions)

    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    hideLoadingIndicator(): void;
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    showLoadingIndicator(): void;
}
