/**
* DevExtreme (viz/tree_map.d.ts)
* Version: 21.1.0 (build 20361-0317)
* Build date: Sat Dec 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../jquery_augmentation';

import {
    dxElement
} from '../core/element';

import {
    PaletteType,
    PaletteExtensionModeType
} from './palette';

import {
    template
} from '../core/templates/template';

import DataSource, {
    DataSourceOptions
} from '../data/data_source';

import {
    event
} from '../events/index';

import BaseWidget, {
    BaseWidgetMargin,
    BaseWidgetOptions,
    BaseWidgetTooltip,
    Font,
    WordWrapType,
    VizTextOverflowType,
} from './core/base_widget';

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTreeMapOptions extends BaseWidgetOptions<dxTreeMap> {
    /**
     */
    childrenField?: string;
    /**
     */
    colorField?: string;
    /**
     */
    colorizer?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      colorCodeField?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      colorizeGroups?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      palette?: Array<string> | PaletteType,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      paletteExtensionMode?: PaletteExtensionModeType,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      range?: Array<number>,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      type?: 'discrete' | 'gradient' | 'none' | 'range'
    };
    /**
     */
    dataSource?: Array<any> | DataSource | DataSourceOptions | string;
    /**
     */
    group?: {
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
      border?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      headerHeight?: number,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hoverEnabled?: boolean,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hoverStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      label?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        font?: Font,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        textOverflow?: VizTextOverflowType,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        visible?: boolean
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      selectionStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string
      }
    };
    /**
     */
    hoverEnabled?: boolean;
    /**
     */
    idField?: string;
    /**
     */
    interactWithGroup?: boolean;
    /**
     */
    labelField?: string;
    /**
     */
    layoutAlgorithm?: 'sliceanddice' | 'squarified' | 'strip' | ((e: { rect?: Array<number>, sum?: number, items?: Array<any> }) => any);
    /**
     */
    layoutDirection?: 'leftBottomRightTop' | 'leftTopRightBottom' | 'rightBottomLeftTop' | 'rightTopLeftBottom';
    /**
     * Warning! This type is used for internal purposes. Do not import it directly.
     */
    margin?: BaseWidgetMargin;
    /**
     */
    maxDepth?: number;
    /**
     */
    onClick?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, event?: event, node?: dxTreeMapNode }) => any) | string;
    /**
     */
    onDrill?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, node?: dxTreeMapNode }) => any);
    /**
     */
    onHoverChanged?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, node?: dxTreeMapNode }) => any);
    /**
     */
    onNodesInitialized?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, root?: dxTreeMapNode }) => any);
    /**
     */
    onNodesRendering?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, node?: dxTreeMapNode }) => any);
    /**
     */
    onSelectionChanged?: ((e: { component?: dxTreeMap, element?: dxElement, model?: any, node?: dxTreeMapNode }) => any);
    /**
     */
    parentField?: string;
    /**
     */
    selectionMode?: 'multiple' | 'none' | 'single';
    /**
     */
    tile?: {
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      border?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        width?: number
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      color?: string,
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      hoverStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      label?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        font?: Font,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        textOverflow?: VizTextOverflowType,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        visible?: boolean,
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        wordWrap?: WordWrapType
      },
      /**
       * Warning! This type is used for internal purposes. Do not import it directly.
       */
      selectionStyle?: {
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        border?: {
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          color?: string,
          /**
           * Warning! This type is used for internal purposes. Do not import it directly.
           */
          width?: number
        },
        /**
         * Warning! This type is used for internal purposes. Do not import it directly.
         */
        color?: string
      }
    };
    /**
     */
    tooltip?: dxTreeMapTooltip;
    /**
     */
    valueField?: string;
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTreeMapTooltip extends BaseWidgetTooltip {
    /**
     * Specifies a custom template for a tooltip.
     */
    contentTemplate?: template | ((info: { value?: number, valueText?: string, node?: dxTreeMapNode }, element: dxElement) => string | Element | JQuery);
    /**
     * Allows you to change tooltip appearance.
     */
    customizeTooltip?: ((info: { value?: number, valueText?: string, node?: dxTreeMapNode }) => any);
}
/**
 */
export default class dxTreeMap extends BaseWidget {
    constructor(element: Element, options?: dxTreeMapOptions)
    constructor(element: JQuery, options?: dxTreeMapOptions)
    /**
     */
    clearSelection(): void;
    /**
     */
    drillUp(): void;
    /**
     */
    getCurrentNode(): dxTreeMapNode;
    getDataSource(): DataSource;
    /**
     */
    getRootNode(): dxTreeMapNode;
    /**
     */
    hideTooltip(): void;
    /**
     */
    resetDrillDown(): void;
}

/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface dxTreeMapNode {
    /**
     */
    customize(options: any): void;
    /**
     */
    data?: any;
    /**
     */
    drillDown(): void;
    /**
     */
    getAllChildren(): Array<dxTreeMapNode>;
    /**
     */
    getAllNodes(): Array<dxTreeMapNode>;
    /**
     */
    getChild(index: number): dxTreeMapNode;
    /**
     */
    getChildrenCount(): number;
    /**
     */
    getParent(): dxTreeMapNode;
    /**
     */
    index?: number;
    /**
     */
    isActive(): boolean;
    /**
     */
    isHovered(): boolean;
    /**
     */
    isLeaf(): boolean;
    /**
     */
    isSelected(): boolean;
    /**
     */
    label(): string;
    /**
     */
    label(label: string): void;
    /**
     */
    level?: number;
    /**
     */
    resetCustomization(): void;
    /**
     */
    select(state: boolean): void;
    /**
     */
    showTooltip(): void;
    /**
     */
    value(): number;
}

declare global {
interface JQuery {
    dxTreeMap(): JQuery;
    dxTreeMap(options: "instance"): dxTreeMap;
    dxTreeMap(options: string): any;
    dxTreeMap(options: string, ...params: any[]): any;
    dxTreeMap(options: dxTreeMapOptions): JQuery;
}
}
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type Options = dxTreeMapOptions;

/** @deprecated use Options instead */
/**
 * Warning! This type is used for internal purposes. Do not import it directly.
 */
export type IOptions = dxTreeMapOptions;
